/*
*  IRC Services
*
*  Copyright (C) 2003 Services Developers
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of version 1 of the GNU General Public License,
*  as published by the Free Software Foundation.
*
*  This program is distributed in the hope that it will be useful, but
*  WITHOUT ANY WARRANTY; without even the warranty of MERCHANTABILITY
*  or FITNESS FOR A PARTICULAR PURPOSE. The GNU General Public License
*  contains more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* $Id: csnuggle.h,v 1.6 2003/10/31 15:53:20 wcampbel Exp $
*/

#include "defines.h"

typedef struct csnuggle
{
  struct csnuggle *next;
  char *creator;
  char *chan;
  char *reason;
  u_short type;
  u_int32_t matches;
  time_t created;
}
csnuggle_t;

typedef struct _csnuggle_type
{
  char *name;
  u_short qtype;
}
csnuggle_type;

extern csnuggle_type csnuggle_types[];

void	add_csnuggle	(char *, char *, char *, u_short, time_t); /* creator:chan:reason:type:TS */
int	del_csnuggle	(sock_t *, char *); /* creator:chan:reason */
void	del_all_csnuggles	(void);
csnuggle_t *	find_csnuggle	(char *); /* creator:chan:reason */
int	list_csnuggles	(sock_t *, char *, u_short);
int	match_csnuggle	(user_t *, char *);
char *	md5_csnuggle	(csnuggle_t *);
