/*
*  IRC Services
*
*  Copyright (C) 2003 Services Developers
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of version 1 of the GNU General Public License,
*  as published by the Free Software Foundation.
*
*  This program is distributed in the hope that it will be useful, but
*  WITHOUT ANY WARRANTY; without even the warranty of MERCHANTABILITY
*  or FITNESS FOR A PARTICULAR PURPOSE. The GNU General Public License
*  contains more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
*  $Id: privs.h,v 1.5 2003/09/27 16:14:39 wcampbel Exp $
*/

#ifndef PRIVS_H
#define PRIVS_H

/* we're working with an unsigned short 16 bit integer */
#define NOPRIV		0x0000
#define NOKILL		0x0001
#define SERVER		0x0002
#define OPER		0x0008
#define AUTH		0x0010
#define SVSOP		0x0040
#define CADMIN		0x0080
#define ADMIN		0x0100

/* macros that work with above flags */
#define IsOper(x)	(x->privs & OPER)
#define IsServer(x)	(x->privs & SERVER)
#define IsPerson(x)	(!(x->privs & SERVER))
#define NoKill(x)	(x->privs & NOKILL)
#define	IsAuth(x)	(x->privs & AUTH)
#define	SetAuth(x)	(x->privs |= AUTH)
#define	ClearAuth(x)	(x->privs &= ~AUTH)

#endif
