/*
*  IRC Services
*
*  Copyright (C) 2003 Services Developers
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of version 1 of the GNU General Public License,
*  as published by the Free Software Foundation.
*
*  This program is distributed in the hope that it will be useful, but
*  WITHOUT ANY WARRANTY; without even the warranty of MERCHANTABILITY
*  or FITNESS FOR A PARTICULAR PURPOSE. The GNU General Public License
*  contains more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* $Id: help.c,v 1.37 2003/10/12 18:31:01 wcampbel Exp $
*/

#include "config.h"
#include "defines.h"
#include "replies.h"
#include "privs.h"
#include "help.h"
#include "send.h"
#include "me.h"

u_short
help(user_t *cptr, u_short v)
{
  reply(cptr->nick, replies[RPL_HELP_A], me.os_nick);
  reply(cptr->nick, " ");

  reply(cptr->nick, "Operator commands:");
  reply(cptr->nick, "\2MODE\2        Change a channel's modes");
  reply(cptr->nick, "\2KICK\2        Kick a user from a channel");
  reply(cptr->nick, "\2KILL\2        Kill a user off the network");
  reply(cptr->nick, "\2GLINE\2       GLINE a given usermask@hostmask");
  reply(cptr->nick, "\2ANONGLINE\2   Anonymously GLINE a given usermask@hostmask");
  reply(cptr->nick, "\2UNGLINE\2     UNGLINE a given user@hostmask from all servers.");
  reply(cptr->nick, "\2PLACEHOLD\2   Makes a placeholder for a nick not in use");
  reply(cptr->nick, "\2CLONES\2      Lists all unauthorized clones");
  reply(cptr->nick, "\2KILLCLONES\2  Kills all unauthorized clones");
  if (me.servtype == SERV_IRCNN)
    reply(cptr->nick, "\2SETTIME\2     Syncronize the servers' clocks with mine");
  reply(cptr->nick, "\2SNUGGLEID\2   Find out what is snuggled, by ID number");
  reply(cptr->nick, "\2CSNUGGLEID\2  Find out what channel is csnuggle by ID Number");
  if (me.servtype == SERV_IRCNN)
    reply(cptr->nick, "\2GLOBAL\2     Send a GLOBAL Messages to all users!");
  reply(cptr->nick, " ");
  reply(cptr->nick, "Remember, all commands sent to %s are logged!", me.os_nick);
  return 1;
}

void
os_mode_help(user_t *cptr, u_short v)
{
  reply(cptr->nick, "Usage: \2MODE #channel [modes]\2");
}

void
os_global_help(user_t *cptr, u_short v)
{
  reply(cptr->nick, "Usage: \2GLOBAL :[message]\2");
}

void
os_kick_help(user_t *cptr, u_short v)
{
  reply(cptr->nick, "Usage: \2KICK #channel nick reason...\2");
}

void
os_kill_help(user_t *cptr, u_short v)
{
  reply(cptr->nick, "Usage: \2KILL nick reason...\2");
}

void
os_gline_help(user_t *cptr, u_short v)
{
  reply(cptr->nick, "Usage: (\2GLINE\2|\2ANONGLINE\2) user@host hours reason...\2");
  if (!v)
    return ;
  reply(cptr->nick, "Bans a user@host from the network for the number of hours specified.");
  reply(cptr->nick, "ANONGLINE is the anonymous version of GLINE. Operator host will be logged.");
  reply(cptr->nick, "\2All\2 GLINE/ANONGLINE will be issued a \2GLINE ID\2 for tracking purposes.");
}

void
os_ungline_help(user_t *cptr, u_short v)
{
  reply(cptr->nick, "Usage: (\2UNGLINE\2) user@host");
  if (!v)
    return ;
  reply(cptr->nick, "Removes a banned user@host from being k-lined.");
  reply(cptr->nick, "Warning:  Not usable on ircnn.");
}

void
os_snuggleid_help(user_t *cptr, u_short v)
{
  reply(cptr->nick, "Usage: (\2SNUGGLEID\2) ID#");
  if (!v)
    return ;
  reply(cptr->nick, "Look up a SNUGGLE ID number to see what is snuggled");
}

void
os_csnuggleid_help(user_t *cptr, u_short v)
{
  reply(cptr->nick, "Usage: (\2CSNUGGLEID\2) ID#");
  if (!v)
    return ;
  reply(cptr->nick, "Look up a CSNUGGLE ID number to see what it is");
}
