/*
*  IRC Services
*
*  Copyright (C) 2003 Services Developers
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of version 1 of the GNU General Public License,
*  as published by the Free Software Foundation.
*
*  This program is distributed in the hope that it will be useful, but
*  WITHOUT ANY WARRANTY; without even the warranty of MERCHANTABILITY
*  or FITNESS FOR A PARTICULAR PURPOSE. The GNU General Public License
*  contains more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* $Id: sclients.c,v 1.16 2003/09/27 16:14:40 wcampbel Exp $
*/

#include "irc_types.h"
#include "irc_string.h"
#include "channels.h"
#include "sclients.h"
#include "defines.h"
#include "privs.h"
#include "mem.h"
#include "net.h"
#include "me.h"

void
intro_nicks(void)
{
  switch (me.servtype)
  {
    case SERV_IRCNN:
      toserv(":%s NICK %s 1 %lu %s %s %s :%s", me.servname, me.os_nick, time(NULL),
             me.os_username, me.servname, me.servname, me.os_gecos);
      toserv(":%s MODE %s :+ko", me.os_nick, me.os_nick);
      me.opers++;
      add_user(me.os_nick, me.os_username, me.servname, me.os_gecos,
               me.servname, NOKILL);
      break;

    case SERV_HYBRD:
      toserv(":%s NICK %s 1 %lu +omw %s %s %s :%s", me.servname,
             me.os_nick, time(NULL), me.os_username, me.servname,
             me.servname, me.os_gecos);
      me.opers++;
      add_user(me.os_nick, me.os_username, me.servname, me.os_gecos,
               me.servname, NOKILL);
      me.htmtime = time(NULL);
      if (me.eob == 1)
        join_channels();

      break;
  }
  if ((me.nickpass != NULL) && (me.nickserv != NULL))
  {
    toserv(":%s PRIVMSG %s :identify %s", me.os_nick, me.nickserv,
           me.nickpass);
  }
}

u_short
is_services_client(char *nick)
{
  if (strcasecmp(nick, me.os_nick) == 0)
    return 1;
  return 0;
}
